Package org.optaplanner.core.impl.score.stream.drools.common

## Class DroolsAbstractConstraintStream<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>

- All Implemented Interfaces:
    `ConstraintStream`
  Direct Known Subclasses:
    `DroolsAbstractBiConstraintStream`, `DroolsAbstractQuadConstraintStream`, `DroolsAbstractTriConstraintStream`, `DroolsAbstractUniConstraintStream`

      public abstract class DroolsAbstractConstraintStream<Solution_>
      extends AbstractConstraintStream<Solution_>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected DroolsConstraintFactory<Solution_>` | `constraintFactory` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsAbstractConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addChildStream​(DroolsAbstractConstraintStream<Solution_> childStream)` |
    `protected DroolsConstraint<Solution_>` | `buildConstraint​(String constraintPackage, String constraintName, Score<?> constraintWeight, ScoreImpactType impactType, AbstractConstraintConsequence consequence)` |
    `protected DroolsConstraint<Solution_>` | `buildConstraintConfigurable​(String constraintPackage, String constraintName, ScoreImpactType impactType, AbstractConstraintConsequence constraintConsequence)` |
    `Collection<DroolsAbstractConstraintStream<Solution_>>` | `getChildStreams()` |
    `DroolsConstraintFactory<Solution_>` | `getConstraintFactory()` | The `ConstraintFactory` that build this.

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, getCardinality, impact, impactScore, impactScoreConfigurable, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

- - ### Field Detail

    - #### constraintFactory

          protected final DroolsConstraintFactory<Solution_> constraintFactory

  - ### Constructor Detail

    - #### DroolsAbstractConstraintStream

          public DroolsAbstractConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory)

  - ### Method Detail

    - #### buildConstraint

          protected DroolsConstraint<Solution_> buildConstraint​(String constraintPackage,
                                                                String constraintName,
                                                                Score<?> constraintWeight,
                                                                ScoreImpactType impactType,
                                                                AbstractConstraintConsequence consequence)

    - #### buildConstraintConfigurable

          protected DroolsConstraint<Solution_> buildConstraintConfigurable​(String constraintPackage,
                                                                            String constraintName,
                                                                            ScoreImpactType impactType,
                                                                            AbstractConstraintConsequence constraintConsequence)

    - #### addChildStream

          public void addChildStream​(DroolsAbstractConstraintStream<Solution_> childStream)

    - #### getChildStreams

          public Collection<DroolsAbstractConstraintStream<Solution_>> getChildStreams()

    - #### getConstraintFactory

          public DroolsConstraintFactory<Solution_> getConstraintFactory()

      Description copied from interface: `ConstraintStream`
      The `ConstraintFactory` that build this.
      Specified by:
        `getConstraintFactory` in interface `ConstraintStream`
      Specified by:
        `getConstraintFactory` in class `AbstractConstraintStream<Solution_>`
      Returns:
        never null